; File:         Char1b.asm
; Author:       RuiLoureiro
; Date:         23 /06 /2005
; Assembled in Quick Editor in Project -> Console Assemble & Link
; 
.486 
.model flat,stdcall 
option casemap:none 
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Key_Input_Record structure:
;
EVENTTYPE$        equ 0       ; (w)
KEYPRESSED$       equ 4       ; (w)
REPEATCOUNT$      equ 8       ; (w)
VIRTUALKEYCOD$    equ 10      ; (w)
ASCIICODEHI$      equ 12      ; (w) If ASCIICODELO$ = 0
ASCIICODELO$      equ 14      ; (w)
CONTROLKEY$       equ 16      ; (w) while Ctrl, Alt, etc. is pressed

;----------------------------------------------------------------------------------------------
include \masm32\include\windows.inc
;**********************************************************************************************
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc 
include \masm32\include\masm32.inc
; ---------------------------------------------------------------------------------------------
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

include \masm32\macros\macros.asm
include \masm32\macros\ucmacros.asm

$LENINPUTRECORD$   equ 20            ; length of each INPUT_RECORD
$MAXINPUTBUFFER$   equ 20            ; max number of input records
;-------------------------------------------------------------------------------------------
.data
align 4
                  dd 0                 ; -16 last key pressed
                  dd 0                 ; -12 current record pointer
                  dd 0                 ;  -8 number of records read
                  dd $MAXINPUTBUFFER$  ;  -4 number of record structures
_InputBuffer      db $LENINPUTRECORD$*$MAXINPUTBUFFER$ dup (?)
; 
       dd 4
WSTR  _UniErro, "Erro" 
       dd 30
WSTR  _MsgUniString, "Type any key to continue ...  " 

       dd 24
WSTR  _UniString1, " j s ngremes aces "  ; testar acentos
       dd 24
WSTR  _UniString2, "  j s ngremes ACES"  ; testar acentos
       dd 48
WSTR  _UniString3, "   -           -          "  ; testar acentos


; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.data?
_hScreenBuffer    dd ?
_hInputBuffer     dd ?
;----------------------------------------------------------------------------------------------
.code 
; 
start:           call     HndInOutGet    
                 jc       _eStart
                 ;
                 call      KeyOneIni

                 mov       edx, offset _MsgUniString 
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrintStop                  
                 jc        short _erro                       

                 mov       edx, offset _UniString1 
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrintStop                  
                 jc        short _erro                       
                 
                 mov       edx, offset _UniString2
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrintStop                  
                 jc        short _erro

                 mov       edx, offset _UniString3
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrintStop                  
                 jnc       short _sbStart
                 ;
_erro:           mov       edx, offset _UniErro 
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrintStop                  
                 ;
                 ; close all
                 ; ---------
_sbStart:	     invoke	  CloseHandle, _hScreenBuffer       ; Close screen buffer
                 invoke   CloseHandle, _hInputBuffer        ; Close input buffer
                 
_eStart:         invoke	  ExitProcess, 0
; ==============================================
;                    *****         PROCEDURES          *****
; 
HndInOutGet       proc  
                  invoke   GetStdHandle, STD_INPUT_HANDLE     
	            cmp      eax, INVALID_HANDLE_VALUE
                  jne      short @F
                  ;
                  stc
                  ret	
                  ;
                  ; This is the SCREEN number 0
                  ; ---------------------------
@@:               mov      _hInputBuffer, eax                     ; input buffer handle
                  ;
                  invoke   GetStdHandle, STD_OUTPUT_HANDLE    
	            cmp      eax, INVALID_HANDLE_VALUE
                  jne      short @F
                  ;
                  invoke   CloseHandle, _hInputBuffer             ; Close input buffer
                  stc
                  ret
                  ; ----------------------
                  ; Get screen buffer info
                  ; ----------------------
@@:               mov      _hScreenBuffer, eax                    ; screen buffer handle
                  clc
                  ret
HndInOutGet       endp                 
; 
; Action:
;        Print the buffer (UNICODE) pointed by EDX.
;
; Input:
;        EDX   - Buffer string pointer
;        ECX   - buffer's length
;
BufferPrint         proc    
                    LOCAL   wNum:DWORD
                    pushad
                    ;
                    or       ecx, ecx
                    jz       short @F
                    
                    push     ecx
                        invoke   WriteConsoleW, _hScreenBuffer,       ; handle
                                                edx,                  ; print buffer
                                                ecx,                  ; write ECX char
                                                ADDR wNum,            ; Number written
                                                0                     ;
                    pop     ecx
                    ;
                    cmp     eax, 0
                    jne     short @F
                    ;
                    lea     ebx, wNum
                    cmp     ecx, dword ptr [ebx]
                    je      short @F
                    
                    stc                     ; error
                    popad
                    ret

@@:                 clc                     ; is done !
                    popad
                    ret
BufferPrint         endp
; ---------------------------------------------------------------------------------------------
BufferPrintStop     proc    
                    call   BufferPrint
                    jc     short @F
                    ;                 
                    call    KeyOneWait
@@:                 ret
BufferPrintStop     endp    
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Action:
;
; Out:
;       clc: key was pressed -> exit
;
;       stc: error
;
KeyOneWait          proc
                    pushad

                    mov      ebx, offset _InputBuffer
                    cmp      dword ptr [ebx - 16], 0
                    je       short _iKeyOneWait2
                    jne      short _iKeyOneWait1

@@:                 call     RecordsFill
                    jc       short _eKeyOneWait                       

_iKeyOneWait1:      call     KeyReleasedVrf
                    jc       short @B                       
                    jnc      short _iKeyOneWait2

                    ; ------------------------
                    ; Read at least ONE RECORD
                    ; ------------------------
@@:                 call     RecordsFill
                    jc       short _eKeyOneWait                            
                    
_iKeyOneWait2:      call     KeyPressedVrf
                    jc       short @B

_eKeyOneWait:       popad
                    ret
KeyOneWait          endp 
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; In:
;    EBX     - Input record pointer
;
; Out:
;     clc:    pressed
;
;     stc:    
;
KeyPressedVrf       proc

                    mov    esi, dword ptr [ebx - 12]
                    mov    ecx, dword ptr [ebx - 8]
                    or     ecx, ecx            
                    jnz    short iKeyPressedVrf
                    ;
                    stc
                    ret

@@:                 add    esi, $LENINPUTRECORD$                                
                    dec    ecx
                    mov    dword ptr [ebx - 8], ecx
                    jnz    short iKeyPressedVrf
                    ;
                    stc
                    ret
                    ;
iKeyPressedVrf:     cmp    word ptr [esi + EVENTTYPE$], KEY_EVENT            ; EventType
                    jne    short @B
                    ;
                    cmp    word ptr [esi + KEYPRESSED$], 1                   ; Key pressed
                    jne    short @B
                    ; 
                    ; Last key pressed
                    ; ----------------
                    mov    ax, word ptr [esi + ASCIICODEHI$]
                    shl    eax, 16
                    mov    ax, word ptr [esi + ASCIICODELO$]
                    mov    dword ptr [ebx - 16], eax
                    jmp    _eKeyReleasedVrf
                    ;
;                    dec    ecx
;                    mov    dword ptr [ebx - 8], ecx
;                    jz     short @F
                    ;                 
;                    add    esi, $LENINPUTRECORD$
;                    mov    dword ptr [ebx - 12], esi
                    ;
;@@:                 clc
;                    ret
 KeyPressedVrf      endp
; ---------------------------------------------------------------------------------------------
; In:
;    EBX     - Input record pointer
;
; Out:
;     clc:    released
;             ESI     - next record
;             ECX     - number of records
;
;     stc:    
;
KeyReleasedVrf      proc
                    
                    mov    esi, dword ptr [ebx - 12]
                    mov    ecx, dword ptr [ebx - 8]
                    or     ecx, ecx            
                    jnz    short iKeyReleasedVrf
                    ;
                    stc
                    ret
                    ;
@@:                 add    esi, $LENINPUTRECORD$                                
                    dec    ecx
                    mov    dword ptr [ebx - 8], ecx
                    jnz    short iKeyReleasedVrf
                    ;
                    stc
                    ret
                    ;
iKeyReleasedVrf:    cmp    word ptr [esi + EVENTTYPE$], KEY_EVENT    ; EventType
                    jne    short @B
                    ;
                    cmp    word ptr [esi + KEYPRESSED$], 0           ; Key released
                    jne    short @B
                    ; 
                    ; Last key pressed
                    ; ----------------
                    mov    ax, word ptr [esi + ASCIICODEHI$]
                    shl    eax, 16
                    mov    ax, word ptr [esi + ASCIICODELO$]
                    ;
                    cmp    eax, dword ptr [ebx - 16]
                    jne    short @B

                    mov    dword ptr [ebx - 16], 0
                    ;
_eKeyReleasedVrf::  dec    ecx
                    mov    dword ptr [ebx - 8], ecx
                    jz     short @F
                    ;
                    add    esi, $LENINPUTRECORD$
                    mov    dword ptr [ebx - 12], esi
                    ;
@@:                 clc
                    ret
KeyReleasedVrf      endp
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
; Action:
;        Reads records to _InputBuffer
;        Initializes current input record pointer
;
; Out:
;        clc:   Ok
;
;        stc:   error
;
RecordsFill         proc
                    pushad

                    mov      ebx, offset _InputBuffer
                    mov      dword ptr [ebx - 12], ebx  ; current input record pointer
                    ;
                    ; One key was pressed, thus 
                    ; -------------------------
_iRecordsFill:      invoke    ReadConsoleInputW, _hInputBuffer,          
                                                 ebx,       
                                                 $MAXINPUTBUFFER$,        
                                                 ADDR _InputBuffer - 8 
                    cmp      eax, 0
                    jne      _eRecordsFill                                  ; not error
                    ;         
                    stc
                    popad
                    ret
                    ;
_eRecordsFill:      cmp      dword ptr [_InputBuffer - 8], 0
                    je       short _iRecordsFill

                    clc
                    popad
                    ret
RecordsFill         endp
; ---------------------------------------------------------------------------------------------
KeyOneIni           proc
                    push   ebx

                    ; ------------------
                    ; Clean input buffer
                    ; ------------------
                    invoke    FlushConsoleInputBuffer, _hInputBuffer

                    mov    ebx, offset _InputBuffer
                    mov    dword ptr [ebx - 12], ebx 
                    mov    dword ptr [ebx - 16], 0 
                    mov    dword ptr [ebx - 8], 0
                    
                    pop    ebx
                    ret
KeyOneIni           endp
; 
END start

